//----------------------------------------------------------------------------
// Copyright (c) 2008-2016 Fabrice HARROUET (ENIB)
//
// This file is part of TransProg.
//   http://www.enib.fr/~harrouet/transprog.html
//
// TransProg is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// TransProg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------

#include "TransProg/asyncCall.h"

void
myFunction1(uint64_t arg1,
            uint64_t arg2,
            uint64_t arg3,
            uint64_t arg4,
            uint64_t arg5,
            uint64_t arg6,
            uint64_t arg7,
            uint64_t arg8)
{
Platform_msg("---- %s() ----\n",__func__);
Platform_msg("  %"F64"X at %p\n",arg1,(void *)&arg1);
Platform_msg("  %"F64"X at %p\n",arg2,(void *)&arg2);
Platform_msg("  %"F64"X at %p\n",arg3,(void *)&arg3);
Platform_msg("  %"F64"X at %p\n",arg4,(void *)&arg4);
Platform_msg("  %"F64"X at %p\n",arg5,(void *)&arg5);
Platform_msg("  %"F64"X at %p\n",arg6,(void *)&arg6);
Platform_msg("  %"F64"X at %p\n",arg7,(void *)&arg7);
Platform_msg("  %"F64"X at %p\n",arg8,(void *)&arg8);
}

int
myFunction2(uint8_t arg1,
            uint16_t arg2,
            uint32_t arg3,
            uint64_t arg4,
            real32_t arg5,
            real64_t arg6,
            char **arg7)
{
Platform_msg("---- %s() ----\n",__func__);
Platform_msg("  %X at %p\n",arg1,(void *)&arg1);
Platform_msg("  %X at %p\n",arg2,(void *)&arg2);
Platform_msg("  %X at %p\n",arg3,(void *)&arg3);
Platform_msg("  %"F64"X at %p\n",arg4,(void *)&arg4);
Platform_msg("  %g at %p\n",arg5,(void *)&arg5);
Platform_msg("  %g at %p\n",arg6,(void *)&arg6);
Platform_msg("  %p at %p\n",(void *)arg7,(void *)&arg7);
int i;
for(i=0;arg7[i];++i)
  {
  Platform_msg("    %s\n",arg7[i]);
  }
return i;
}

AsyncCall_typedef_8_void(AsyncCallF1,
                         uint64_t,uint64_t,uint64_t,uint64_t,
                         uint64_t,uint64_t,uint64_t,uint64_t)

AsyncCall_typedef_7(int,AsyncCallF2,
                    uint8_t,uint16_t,uint32_t,uint64_t,
                    real32_t,real64_t,char **)

int
main(int argc,
     char **argv)
{
Platform_init(argc,argv);
AsyncCallF1 *ac1=AsyncCallF1_new(&myFunction1,
                                 0x0101010101010101,
                                 0x2323232323232323,
                                 0x4545454545454545,
                                 0x6767676767676767,
                                 0x8989898989898989,
                                 0xABABABABABABABAB,
                                 0xCDCDCDCDCDCDCDCD,
                                 0xEFEFEFEFEFEFEFEF);
AsyncCallF2 *ac2=AsyncCallF2_new(&myFunction2,
                                 0xAA,0xBBBB,0xCCCCCCCC,0xDDDDDDDDDDDDDDDD,
                                 5.5,6.6,argv);
AsyncCallF1 *ac3=AsyncCallF1_new(&myFunction1,
                                 0xEFEFEFEFEFEFEFEF,
                                 0xCDCDCDCDCDCDCDCD,
                                 0xABABABABABABABAB,
                                 0x8989898989898989,
                                 0x6767676767676767,
                                 0x4545454545454545,
                                 0x2323232323232323,
                                 0x0101010101010101);
AsyncCallF2 *ac4=AsyncCallF2_new(&myFunction2,
                                 0xDD,0xCCCC,0xBBBBBBBB,0xAAAAAAAAAAAAAAAA,
                                 50.5,60.6,argv+1);
AsyncCall_execute(ac1);
AsyncCall_execute(ac2);
Platform_msg("  ----> %d\n",AsyncCall_result(ac2));
AsyncCall_execute(ac3);
AsyncCall_execute(ac4);
Platform_msg("  ----> %d\n",AsyncCall_result(ac4));
AsyncCall_delete(ac1);
AsyncCall_delete(ac2);
AsyncCall_delete(ac3);
AsyncCall_delete(ac4);
return 0;
}

DECLARE_WINDOWS_MAIN_FUNCTION

//----------------------------------------------------------------------------
