#!/usr/bin/env python
# -*- coding: utf-8 -*-
#-----------------------------------------------------------------------------
# Copyright (C) 2008-2016 Fabrice HARROUET (ENIB)
#
# This file is part of TransProg.
#   http://www.enib.fr/~harrouet/transprog.html
# 
# TransProg is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# TransProg is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
#-----------------------------------------------------------------------------

import sys ; sys.path.insert(0,'./lib')
import TransProgConfig

import os
import subprocess
import traceback

tool=TransProgConfig.Tool()

if len(sys.argv)>1 and sys.argv[1]=='--full':
  try:
    cmdLine=[tool.python(),sys.argv[0],'--clean']
    subprocess.Popen(cmdLine).wait()
    cmdLine=[tool.python(),sys.argv[0]]+sys.argv[2:]
    subprocess.Popen(cmdLine).wait()
    cmdLine=[tool.python(),sys.argv[0],'--make']
    if not tool.testBoolOption('use_msc'):
      cmdLine.append('-j')
    subprocess.Popen(cmdLine).wait()
  except:
    traceback.print_exc()
    sys.exit(1)
  sys.exit(0)

src=[i for i in [os.path.join('src',j)
                 for j in ['TransProg','TransGl','TransCuda']]
       if os.path.isdir(i)]
tests=[i for i in [os.path.join('Tests',j)
                   for j in os.listdir('Tests')]
         if os.path.isdir(i)]

here=os.getcwd()

cmdLine=[tool.python(),'configure.py']+sys.argv[1:]

for i in src+tests:
  sys.stdout.write('\n---------------- in %s ----------------\n\n'%i)
  os.chdir(os.path.join(here,i))
  try:
    subprocess.Popen(cmdLine).wait()
  except:
    traceback.print_exc()

#-----------------------------------------------------------------------------
