//----------------------------------------------------------------------------
// Copyright (c) 2008-2016 Fabrice HARROUET (ENIB)
//
// This file is part of TransProg.
//   http://www.enib.fr/~harrouet/transprog.html
//
// TransProg is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// TransProg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------

#ifndef TRANSPROG_EXAMINER_H
#define TRANSPROG_EXAMINER_H 1

#include "TransProg/gfxUtils.h"

typedef struct _Examiner
{
bool pending;
GfxButton button;
int mouseX;
int mouseY;
} Examiner;

INLINE
void
Examiner_init(Examiner *e)
{
e->pending=false;
e->button=GFX_NO_BTN;
e->mouseX=0;
e->mouseY=0;
}

INLINE
Examiner *
Examiner_new(void)
{
Examiner *e=Memory_alloc(1,Examiner);
Examiner_init(e);
return e;
}

INLINE
void
Examiner_destroy(Examiner *e)
{
(void)e; // nothing to be done
}

INLINE
void
Examiner_delete(Examiner *e)
{
Examiner_destroy(e);
Memory_free(e);
}

TRANSPROG_API
bool // event used
Examiner_handleEvent(Examiner *e,
                     const GfxState *state,
                     SpatialBasis *location,
                     real64_t refDistance);

#endif // TRANSPROG_EXAMINER_H

//----------------------------------------------------------------------------
