//----------------------------------------------------------------------------
// Copyright (c) 2008-2016 Fabrice HARROUET (ENIB)
//
// This file is part of TransProg.
//   http://www.enib.fr/~harrouet/transprog.html
//
// TransProg is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// TransProg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------

#include "TransProg/random.h"
#include "TransProg/memory.h"

TRANSPROG_API_VAR struct _RandomSeed _Random_seeds[ASSUMED_MAX_CPU_COUNT];

void
_Random_init(void)
{
for(int cpu=0,cpu_end=Platform_cpuCtxCount();cpu<cpu_end;++cpu)
  {
  uint64_t s=Platform_time();
  for(int i=0;i<cpu;++i)
    {
    s=(s<<63)|(s>>1);
    }
  struct _RandomSeed *seed=_Random_seeds+cpu;
  seed->s[1]=(uint32_t)s;
  seed->s[0]=(uint32_t)((s>>32)^s);
  }
}

//----------------------------------------------------------------------------
